﻿Imports System.Drawing.Drawing2D
Public Class Form1
    Function ClockImage(ByVal CanvasSize As Integer, ByVal DrawDate As Date) As Image

        Dim DrawSize As Integer

        If CanvasSize < 1 Then
            CanvasSize = 1
        End If
        If CanvasSize < 400 Then
            DrawSize = 400
        Else
            DrawSize = CanvasSize
        End If

        Dim DrawBitmap As Bitmap = New Bitmap(DrawSize, DrawSize)
        Dim g As Graphics = Graphics.FromImage(DrawBitmap)

        g.ScaleTransform(DrawSize / 400, DrawSize / 400)
        g.TranslateTransform(400 \ 2, 400 \ 2)   ' 原点を中央に持ってくる
        g.SmoothingMode = SmoothingMode.HighQuality

        Dim OuterCircle As Integer = 200 * 0.9  ' 外側の枠の半径
        Dim rect As Rectangle
        Dim gpath As GraphicsPath
        Dim PathBrush As PathGradientBrush

        ' 一番外側の枠

        gpath = New GraphicsPath()
        rect = CenterRect(OuterCircle)

        gpath.AddEllipse(rect)
        PathBrush = New PathGradientBrush(gpath)

        PathBrush.CenterPoint = New PointF(OuterCircle * -0.6, OuterCircle * -0.6)
        PathBrush.SurroundColors = New Color() {Color.FromArgb(160, 103, 30)}
        PathBrush.CenterColor = Color.FromArgb(232, 187, 128)

        g.FillEllipse(PathBrush, rect)

        ' 次の枠

        Dim InnerCircle As Integer = OuterCircle * 0.88
        rect = CenterRect(InnerCircle)

        Dim lgb As LinearGradientBrush = New LinearGradientBrush(rect, Color.FromArgb(64, 64, 64), Color.FromArgb(230, 230, 230), LinearGradientMode.ForwardDiagonal)
        g.FillEllipse(lgb, rect)

        ' アクセント部分

        Dim AccentCircle As Integer = OuterCircle * 0.84
        rect = CenterRect(AccentCircle)
        Dim sb As SolidBrush = New SolidBrush(Color.FromArgb(64, 64, 64))
        g.FillEllipse(sb, rect)

        ' 文字盤

        Dim bl As Blend = New Blend(3)
        bl.Positions = New Single() {0, 0.35, 1}
        bl.Factors = New Single() {0, 1, 1}

        Dim MainCircle As Integer = OuterCircle * 0.83
        gpath = New GraphicsPath()
        rect = CenterRect(MainCircle)
        gpath.AddEllipse(rect)
        PathBrush = New PathGradientBrush(gpath)

        PathBrush.CenterColor = Color.FromArgb(255, 255, 255)
        PathBrush.SurroundColors = New Color() {Color.FromArgb(212, 212, 212)}
        PathBrush.Blend = bl

        g.FillEllipse(PathBrush, rect)

        ' 中央の枠

        Dim CenterCircle As Integer = OuterCircle * 0.35

        sb = New SolidBrush(Color.FromArgb(215, 215, 215))
        rect = CenterRect(CenterCircle)
        g.DrawEllipse(New Pen(Color.FromArgb(215, 215, 215), CenterCircle * 0.09), rect)

        ' 文字盤の印

        sb = New SolidBrush(Color.FromArgb(180, 180, 255))

        Dim d As Integer

        For d = 0 To 330 Step 30
            g.RotateTransform(30)

            rect = New Rectangle(-MainCircle * 0.02, -MainCircle * 0.95, MainCircle * 0.04, MainCircle * 0.14)
            g.FillRectangle(sb, rect)
        Next

        ' 短針

        sb = New SolidBrush(Color.FromArgb(100, 100, 100))

        g.RotateTransform(30 * (DrawDate.Hour + DrawDate.Minute / 60))

        Dim p As Point() = New Point() {New Point(-MainCircle * 0.02, 0), New Point(-MainCircle * 0.02, -MainCircle * 0.5), New Point(-MainCircle * 0.05, -MainCircle * 0.6), New Point(0, -MainCircle * 0.7), _
            New Point(MainCircle * 0.05, -MainCircle * 0.6), New Point(MainCircle * 0.02, -MainCircle * 0.5), New Point(MainCircle * 0.02, 0)}
        g.FillPolygon(sb, p)

        g.RotateTransform(-30 * (DrawDate.Hour + DrawDate.Minute / 60))

        ' 長針

        g.RotateTransform((DrawDate.Minute + DrawDate.Second / 60) * 6)

        p = New Point() {New Point(-MainCircle * 0.02, 0), New Point(-MainCircle * 0.02, -MainCircle * 0.7), New Point(-MainCircle * 0.05, -MainCircle * 0.8), New Point(0, -MainCircle * 0.9), _
            New Point(MainCircle * 0.05, -MainCircle * 0.8), New Point(MainCircle * 0.02, -MainCircle * 0.7), New Point(MainCircle * 0.02, 0)}

        g.FillPolygon(sb, p)

        g.RotateTransform(-(DrawDate.Minute + DrawDate.Second / 60) * 6)

        ' 長針と短針の部分の丸

        rect = CenterRect(MainCircle * 0.05)
        g.FillEllipse(sb, rect)

        ' 秒針

        g.RotateTransform(DrawDate.Second * 6)
        g.DrawLine(New Pen(Color.FromArgb(64, 64, 64), 3), 0, CInt(MainCircle * 0.1), 0, CInt(-MainCircle * 0.92))
        g.RotateTransform(-DrawDate.Second * 6)

        ' 長針と短針の部分の丸

        sb = New SolidBrush(Color.FromArgb(64, 64, 64))
        rect = CenterRect(MainCircle * 0.03)
        g.FillEllipse(sb, rect)

        ' 最後

        If CanvasSize < 400 Then
            Dim ReturnBitmap As Bitmap = New Bitmap(CanvasSize, CanvasSize)
            Dim rg As Graphics = Graphics.FromImage(ReturnBitmap)
            rg.InterpolationMode = InterpolationMode.HighQualityBicubic
            rg.DrawImage(DrawBitmap, New Rectangle(0, 0, CanvasSize, CanvasSize))
            Return ReturnBitmap
        Else
            Return DrawBitmap
        End If

    End Function

    Function CenterRect(ByVal r As Double) As Rectangle

        Return New Rectangle(-r, -r, r * 2, r * 2)

    End Function

    Private Sub Timer1_Tick(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Timer1.Tick

        PictureBox1.Image = ClockImage(PictureBox1.ClientSize.Width, Date.Now)

    End Sub

    Private Sub Form1_Layout(ByVal sender As Object, ByVal e As System.Windows.Forms.LayoutEventArgs) Handles Me.Layout

        Dim s As Integer
        If Me.ClientSize.Width < Me.ClientSize.Height Then
            s = Me.ClientSize.Width
        Else
            s = Me.ClientSize.Height
        End If
        PictureBox1.Size = New Size(s, s)
        PictureBox1.Image = ClockImage(PictureBox1.ClientSize.Width, Date.Now)

    End Sub
End Class
