﻿Imports System.Runtime.InteropServices, System.Diagnostics, System.Drawing.Drawing2D
Public Class Form1

    Shared hHook As Integer = 0
    Shared MousePoint As Point
    Shared MyForm As Form1

    ' コールバック関数へのデリゲート
    Public Delegate Function CallBack( _
        ByVal nCode As Integer, _
        ByVal wParam As IntPtr, _
        ByVal lParam As IntPtr) As Integer

    Dim WH_MOUSE_LL As Integer = 14

    ' コールバック関数を保存するフィールド
    Private hookproc As CallBack

    ' SetWindowsHookEx関数の宣言
    <DllImport("User32.dll", CharSet:=CharSet.Auto, CallingConvention:=CallingConvention.StdCall)> _
     Public Overloads Shared Function SetWindowsHookEx _
          (ByVal idHook As Integer, ByVal HookProc As CallBack, _
           ByVal hInstance As IntPtr, ByVal wParam As Integer) As Integer
    End Function

    ' CallNextHookEx関数の宣言
    <DllImport("User32.dll", CharSet:=CharSet.Auto, CallingConvention:=CallingConvention.StdCall)> _
     Public Overloads Shared Function CallNextHookEx _
          (ByVal idHook As Integer, ByVal nCode As Integer, _
           ByVal wParam As IntPtr, ByVal lParam As IntPtr) As Integer
    End Function

    ' UnhookWindowsHookEx関数の宣言
    <DllImport("User32.dll", CharSet:=CharSet.Auto, CallingConvention:=CallingConvention.StdCall)> _
         Public Overloads Shared Function UnhookWindowsHookEx _
              (ByVal idHook As Integer) As Boolean
    End Function

    ' GetModuleHandle関数の宣言
    <DllImport("kernel32.dll", CharSet:=CharSet.Auto, CallingConvention:=CallingConvention.StdCall)> _
         Public Overloads Shared Function GetModuleHandle _
              (ByVal lpModuleName As String) As IntPtr
    End Function

    ' APIにおけるPoint構造体の宣言
    <StructLayout(LayoutKind.Sequential)> Public Structure WinPoint
        Public x As Integer
        Public y As Integer
    End Structure

    ' MouseHookLLStruct構造体の宣言
    <StructLayout(LayoutKind.Sequential)> Public Structure MouseHookLLStruct
        Public pt As WinPoint
        Public mouseData As UInteger
        Public time As UInteger
        Public dwExtraInfo As IntPtr
    End Structure

    Public Shared Function MouseHookProc(ByVal nCode As Integer, ByVal wParam As IntPtr, ByVal lParam As IntPtr) As Integer

        Dim MyMouseHookStruct As New MouseHookLLStruct()

        If (nCode < 0) Then
            Return CallNextHookEx(hHook, nCode, wParam, lParam)
        End If

        MyMouseHookStruct = CType(Marshal.PtrToStructure(lParam, MyMouseHookStruct.GetType()), MouseHookLLStruct)
        MousePoint = New Point(MyMouseHookStruct.pt.x, MyMouseHookStruct.pt.y)
        Return CallNextHookEx(hHook, nCode, wParam, lParam)

    End Function

    Private Sub Timer1_Tick(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Timer1.Tick

        DrawEye(MousePoint, PictureBox1)
        DrawEye(MousePoint, PictureBox2)

    End Sub

    Sub DrawEye(ByVal MousePoint As Point, ByVal DrawPictureBox As PictureBox)

        ' 座標系を変換
        Dim mp As Point = DrawPictureBox.PointToClient(MousePoint)
        Dim ep As Point ' 黒目の位置(論理座標)
        Dim PicSize As Integer = Math.Min(DrawPictureBox.Width, DrawPictureBox.Height)
        Dim r As Integer = PicSize * 0.25
        Dim ex, ey As Double
        Dim x As Double = mp.X - PicSize \ 2
        Dim y As Double = mp.Y - PicSize \ 2
        Dim InnerEyesize As Integer = PicSize * 0.12

        ' 黒目の位置
        If x = 0 Then
            ep = New Point(0, Math.Sign(y) * r)
        Else
            Dim d As Double = 1 + ((y * y) / (x * x))
            ex = r / Math.Sqrt(d) * Math.Sign(x)
            ey = y / x * ex
            ep = New Point(ex, ey)
        End If

        ep = New Point(ep.X + PicSize \ 2, ep.Y + PicSize \ 2)

        ' 表示
        Dim g As Graphics = Graphics.FromImage(DrawPictureBox.Image)
        g.SmoothingMode = SmoothingMode.AntiAlias
        g.Clear(Color.Transparent)
        Dim BlackPen As Pen = New Pen(Color.Black, Math.Max(PicSize * 0.03, 1))
        Dim WhiteBrush As SolidBrush = New SolidBrush(Color.White)

        Dim Outer As Rectangle = New Rectangle(PicSize * 0.1, PicSize * 0.1, PicSize * 0.8, PicSize * 0.8)

        g.FillEllipse(WhiteBrush, Outer)
        g.DrawEllipse(BlackPen, Outer)

        Dim Inner As Rectangle = New Rectangle(ep.X - InnerEyesize, ep.Y - InnerEyesize, InnerEyesize * 2, InnerEyesize * 2)
        g.FillEllipse(Brushes.Black, Inner)

        g.Dispose()
        DrawPictureBox.Refresh()

    End Sub

    Private Sub Form1_FormClosing(ByVal sender As Object, ByVal e As System.Windows.Forms.FormClosingEventArgs) Handles Me.FormClosing

        Dim ret As Boolean = UnhookWindowsHookEx(hHook)

        If ret.Equals(False) Then
            MessageBox.Show("UnhookWindowsHookEx の実行に失敗しました", Me.Text, MessageBoxButtons.OK, MessageBoxIcon.Error)
            Return
        Else
            hHook = 0
            Timer1.Stop()
        End If

    End Sub

    Private Sub Form1_Layout(ByVal sender As Object, ByVal e As System.Windows.Forms.LayoutEventArgs) Handles Me.Layout

        Dim s = Math.Max(1, Math.Min(Me.ClientSize.Width \ 2, Me.ClientSize.Height))
        PictureBox1.Location = New Point(0, 0)
        PictureBox1.Size = New Size(s, s)
        PictureBox2.Location = New Point(s, 0)
        PictureBox2.Size = New Size(s, s)
        PictureBox1.Image = New Bitmap(PictureBox1.Width, PictureBox1.Height)
        PictureBox2.Image = New Bitmap(PictureBox2.Width, PictureBox2.Height)

    End Sub

    Private Sub Form1_Load(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles MyBase.Load

        ' フックを実行
        hookproc = AddressOf MouseHookProc
        hHook = SetWindowsHookEx(WH_MOUSE_LL, _
                                 hookproc, _
                                 GetModuleHandle(Process.GetCurrentProcess().MainModule.ModuleName), 0)
        If hHook.Equals(0) Then
            MessageBox.Show("SetWindowsHookEx の実行に失敗しました", Me.Text, MessageBoxButtons.OK, MessageBoxIcon.Error)
            Return
        Else
            Timer1.Start()
            MyForm = Me
        End If

    End Sub
End Class
