﻿Public Class Form1

    Const CardNumber As Integer = 16
    Const MaxLife As Integer = 6

    Dim MyRandom As Random = New Random()
    Dim Open1, Open2, Life, Remain As Integer

    Dim Cards() As Integer = New Integer(CardNumber - 1) {}

    Private Sub ExitToolStripMenuItem_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles ExitToolStripMenuItem.Click

        Me.Dispose()

    End Sub

    Private Sub GameStart()

        GameTimer.Stop()

        ' カードは開いていない
        Open1 = -1
        Open2 = -1

        ' カードを初期化
        For i As Integer = 0 To CardNumber - 1
            Cards(i) = i \ 2
        Next

        ' カードをシャッフル
        For i As Integer = 0 To CardNumber - 1
            Dim k = Cards(i)
            Dim n As Integer = Math.Floor(MyRandom.Next(CardNumber))
            Cards(i) = Cards(n)
            Cards(n) = k
        Next

        ' ライフを初期化
        Life = MaxLife
        DisplayLife(Life)

        ' カードを裏返し
        For i As Integer = 0 To CardNumber - 1
            DisplayCard(i, True)
        Next

    End Sub

    Private Sub DisplayLife(ByVal n As Integer)

        If n >= 0 And n <= MaxLife Then
            For i As Integer = 0 To 5
                Dim p As PictureBox = CType(Me.Controls("LifePictureBox" & i), PictureBox)
                If i < n Then
                    p.Visible = True
                Else
                    p.Visible = False
                End If
            Next
        End If

    End Sub

    Private Sub DisplayCard(ByVal n As Integer, ByVal b As Boolean)

        Dim p As PictureBox
        If n >= 0 And n <= (CardNumber - 1) Then
            p = CType(Me.Controls("PictureBox" & n), PictureBox)

            If Cards(n) = -1 Then
                ' カードが取られていてない
                p.Image = Nothing
            ElseIf b Then
                ' バック
                p.Image = My.Resources.CardBack
            Else
                p.Image = GetCardImage("Card" & Cards(n))
            End If
        End If

    End Sub

    Function GetCardImage(ByVal s As String) As Image

        Dim obj As Object = My.Resources.ResourceManager.GetObject(s)
        Return CType(obj, System.Drawing.Bitmap)

    End Function

    Private Sub Form1_Load(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles MyBase.Load

        GameStart()

    End Sub

    Function GetPictureBoxIndex(ByVal p As PictureBox) As Integer

        Dim s As String = p.Name
        Const PictureBoxPrefix As String = "PictureBox"

        Dim i As Integer

        If s.Substring(0, PictureBoxPrefix.Length) = PictureBoxPrefix Then
            i = CType(s.Substring(PictureBoxPrefix.Length), Integer)
        Else
            i = -1
        End If

        Return i

    End Function

    Private Sub PictureBoxes_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles PictureBox0.Click, PictureBox1.Click, PictureBox2.Click, PictureBox3.Click, _
PictureBox4.Click, PictureBox5.Click, PictureBox6.Click, PictureBox7.Click, _
PictureBox8.Click, PictureBox9.Click, PictureBox10.Click, PictureBox11.Click, _
PictureBox12.Click, PictureBox13.Click, PictureBox14.Click, PictureBox15.Click

        Dim CardIndex As Integer = GetPictureBoxIndex(sender)

        If Cards(CardIndex) = -1 Then
            ' すでにとったカード
            Exit Sub
        End If

        If GameTimer.Enabled Then
            ' 2枚とった直後
            Exit Sub
        End If
        If Open1 = -1 Then
            ' 1枚目をオープン
            Open1 = CardIndex
            DisplayCard(CardIndex, False)
        Else
            ' 2枚目をオープン
            If CardIndex = Open1 Then
                ' 同じカードをクリック
                Exit Sub
            End If
            Open2 = CardIndex
            DisplayCard(CardIndex, False)
            Remain = 4
            GameTimer.Start()
        End If

    End Sub

    Function IsComplete() As Boolean

        IsComplete = True

        For i As Integer = 0 To 15
            If Cards(i) <> -1 Then
                IsComplete = False
                Exit For
            End If
        Next

    End Function

    Sub AllOpen()

        ' 残っているカードを開く
        For i As Integer = 0 To 15
            DisplayCard(i, False)
        Next

    End Sub

    Private Sub StartToolStripMenuItem_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles StartToolStripMenuItem.Click

        GameStart()

    End Sub

    Private Sub GameTimer_Tick(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles GameTimer.Tick

        Dim i As Integer
        Remain -= 1

        If Remain = 0 Then

            GameTimer.Stop()

            If Cards(Open1) = Cards(Open2) Then
                ' 開いたカードが一致    
                Cards(Open1) = -1
                Cards(Open2) = -1

                DisplayCard(Open1, False)
                DisplayCard(Open2, False)

                Open1 = -1
                Open2 = -1

                If IsComplete() Then
                    MessageBox.Show("クリアおめでとう!!", "コロボックル神経衰弱", MessageBoxButtons.OK, MessageBoxIcon.Information)
                    GameStart()
                    Exit Sub
                End If
            Else
                ' 残りライフを減少
                Life -= 1
                DisplayLife(Life)

                If Life = 0 Then
                    MessageBox.Show("ゲームオーバーです", "コロボックル神経衰弱", MessageBoxButtons.OK, MessageBoxIcon.Information)
                    AllOpen()
                    Exit Sub
                End If

                ' カードを裏に
                DisplayCard(Open1, True)
                DisplayCard(Open2, True)

                Open1 = -1
                Open2 = -1
            End If
        End If

    End Sub
End Class
