﻿Imports System.IO
Public Class Form1

    Dim ValueList As List(Of Double) = New List(Of Double)()

    Private Sub CalcButton_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles CalcButton.Click

        Dim Value As Double

        If Double.TryParse(TextBox1.Text, Value) Then
            Dim c As Integer = 0
            Do Until c > ValueList.Count - 1 OrElse ValueList(c) > Value
                c += 1
            Loop
            ValueList.Insert(c, Value)
            CountLabel.Text = "数値は" & ValueList.Count & "個です"
            MedianLabel.Text = "中央値は" & GetMedian(ValueList) & "です"
        Else
            MessageBox.Show("実数を入力してください", "エラー", _
            MessageBoxButtons.OK, MessageBoxIcon.Error)
        End If

    End Sub

    Private Sub ClearButton_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles ClearButton.Click

        ValueList.Clear()
        CountLabel.Text = "クリアしました"
        MedianLabel.Text = ""

    End Sub

    Function GetMedian(ByVal ValueList As List(Of Double)) As Double

        Dim c As Integer = ValueList.Count

        If c Mod 2 = 1 Then
            Return ValueList((c + 1) / 2 - 1)
        Else
            Return (ValueList(c / 2 - 1) + ValueList(c / 2)) / 2
        End If

    End Function

    Private Sub Form1_FormClosing(ByVal sender As Object, ByVal e As System.Windows.Forms.FormClosingEventArgs) Handles Me.FormClosing

        Dim sw As StreamWriter
        Try
            sw = New StreamWriter(MedianFileName())
            For i As Integer = 0 To ValueList.Count - 1
                sw.WriteLine(ValueList(i))
            Next
        Catch ex As Exception
            If MessageBox.Show( _
            "書き込みに失敗しました。ファイルを保存せずに終了しますか", Me.Text, _
            MessageBoxButtons.YesNo, MessageBoxIcon.Error) = _
            Windows.Forms.DialogResult.No Then
                e.Cancel = True
            End If
        Finally
            If sw IsNot Nothing Then
                sw.Close()
            End If
        End Try

    End Sub

    Private Sub Form1_Load(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles MyBase.Load

        Dim sr As StreamReader
        Dim Buffer As String
        Dim Value, PrevValue As Double

        Try
            sr = New StreamReader(MedianFileName())
            Buffer = sr.ReadLine()
            Do Until Buffer Is Nothing
                If Not Double.TryParse(Buffer, Value) Then
                    MessageBox.Show("ファイルが不正です")
                    ValueList.Clear()
                    Exit Sub
                End If
                If ValueList.Count > 0 And Value < PrevValue Then
                    MessageBox.Show("ファイルが不正です")
                    ValueList.Clear()
                    Exit Sub
                End If
                ValueList.Add(Value)
                PrevValue = Value
                Buffer = sr.ReadLine()
            Loop
        Catch ex As FileNotFoundException
            ValueList.Clear()
            Exit Sub
        Finally
            If sr IsNot Nothing Then
                sr.Close()
            End If
        End Try
    End Sub

    Function MedianFileName() As String
        Return Path.Combine(Application.StartupPath, "Median.txt")
    End Function

End Class
