﻿Imports System.Drawing.Drawing2D
Public Class Form1

    Dim MyRandom As Random = New Random()
    Dim SnowLocation As List(Of Point) = New List(Of Point)()
    Dim SnowSize As List(Of Integer) = New List(Of Integer)()
    Dim IsSnowing As Boolean

    Private Sub Timer1_Tick(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Timer1.Tick

        If IsSnowing And MyRandom.NextDouble() > 0.4 Then
            SnowLocation.Add(New Point(MyRandom.Next( _
            PictureBox1.Width), -12))
            SnowSize.Add(MyRandom.Next(4, 11))
        End If

        Dim MyBmp As Bitmap = New Bitmap( _
        PictureBox1.Width, PictureBox1.Height)
        Dim BmpGraphics As Graphics = Graphics.FromImage(MyBmp)
        BmpGraphics.SmoothingMode = SmoothingMode.AntiAlias
        BmpGraphics.Clear(Color.Black)

        Dim FallSpeed As Integer
        Dim HorizontalSpeed As Integer
        Dim GrayBrush = New SolidBrush(Color.Gray)
        Dim WhiteBrush = New SolidBrush(Color.White)
        Dim Outer, Inner As Rectangle

        For i As Integer = SnowLocation.Count - 1 To 0 Step -1
            FallSpeed = SnowSize(i) * 0.5
            HorizontalSpeed = MyRandom.Next(-SnowSize(i), _
            SnowSize(i)) / 4
            SnowLocation(i) = New Point(SnowLocation(i).X + _
            HorizontalSpeed, SnowLocation(i).Y + FallSpeed)
            If SnowLocation(i).Y > PictureBox1.Height Then
                SnowLocation.RemoveAt(i)
                SnowSize.RemoveAt(i)
            Else
                Outer = New Rectangle(SnowLocation(i).X, _
                SnowLocation(i).Y, SnowSize(i), SnowSize(i))
                Inner = New Rectangle(SnowLocation(i).X + _
                SnowSize(i) * 0.2, SnowLocation(i).Y + _
                SnowSize(i) * 0.2, SnowSize(i) * 0.6, SnowSize(i) * 0.6)
                BmpGraphics.FillEllipse(GrayBrush, Outer)
                BmpGraphics.FillEllipse(WhiteBrush, Inner)
            End If
        Next

        PictureBox1.Image = MyBmp
        If Not IsSnowing And SnowLocation.Count = 0 Then
            Timer1.Stop()
        End If
        BmpGraphics.Dispose()

    End Sub

    Private Sub StartToolStripMenuItem_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles StartToolStripMenuItem.Click

        IsSnowing = True
        Timer1.Start()

    End Sub

    Private Sub StopToolStripMenuItem_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles StopToolStripMenuItem.Click
        IsSnowing = False
    End Sub

    Private Sub Form1_Load(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles MyBase.Load
        PictureBox1.BackColor = Color.Black
    End Sub

End Class
